> ## Documentation Index
> Fetch the complete documentation index at: https://docs.tesouro.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Get required field names for invoice creation

> Get field requirements for invoice creation given the entity and counterpart details.



## OpenAPI

````yaml /.tooling/schemas/rest/tags/product-finops.json get /finops/v1/receivables/required-fields
openapi: 3.1.0
info:
  title: Tesouro Partner API
  version: '2025-06-23'
  description: The Tesouro REST API, for Tesouro partners to integrate with our solution.
  termsOfService: https://tesouro.com/terms
  contact:
    name: Tesouro team
    url: https://tesouro.com/about/
    email: developers@tesouro.com
servers:
  - url: https://api.sandbox.tesouro.com
    description: Sandbox
security: []
tags:
  - name: Accounting connections
  - name: Accounting data pull
  - name: Accounting synchronized records
  - name: Accounting tax rates
  - name: Analytics
  - name: Approval policies
  - name: Approval requests
  - name: Bank details
  - name: Comments
  - name: Cost centers
  - name: Counterpart VAT IDs
  - name: Counterpart addresses
  - name: Counterpart bank accounts
  - name: Counterpart contacts
  - name: Counterparts
  - name: Credit notes
  - name: Custom tax rates
  - name: Delivery notes
  - name: Documents
  - name: Entities
  - name: Entity users
  - name: Events
  - name: Files
  - name: Identity
  - name: Ledger accounts
  - name: Mail templates
  - name: Mailbox domains
  - name: Mailboxes
  - name: Measure units
  - name: OCR
  - name: Overdue reminders
  - name: PDF templates
  - name: Payable line items
  - name: Payables
  - name: Payment intents
  - name: Payment links
  - name: Payment methods
  - name: Payment records
  - name: Payment reminders
  - name: Payment terms
  - name: Products
  - name: Projects
  - name: Purchase orders
  - name: Receipts
  - name: Receivables
  - name: Recurrences
  - name: Tags
  - name: Text templates
  - name: Transactions
  - name: VAT rates
  - name: Webhook deliveries
  - name: Webhook subscriptions
paths:
  /finops/v1/receivables/required-fields:
    get:
      tags:
        - Receivables
      summary: Get required field names for invoice creation
      description: >-
        Get field requirements for invoice creation given the entity and
        counterpart details.
      operationId: get_receivables_required-fields
      parameters:
        - required: true
          schema:
            type: string
            format: date
          example: '2025-06-23'
          name: x-finops-version
          in: header
        - required: false
          schema:
            type: string
            format: uuid
          name: counterpart_id
          in: query
        - required: false
          schema:
            type: string
            format: uuid
          name: counterpart_billing_address_id
          in: query
        - required: false
          schema:
            $ref: '#/components/schemas/AllowedCountries'
          name: counterpart_country
          in: query
        - required: false
          schema:
            $ref: '#/components/schemas/CounterpartType'
          name: counterpart_type
          in: query
        - required: false
          schema:
            type: string
            format: uuid
          name: entity_vat_id_id
          in: query
        - required: false
          schema:
            type: string
            format: uuid
          name: counterpart_vat_id_id
          in: query
        - description: The ID of the entity that owns the requested resource.
          required: true
          schema:
            type: string
            format: uuid
            examples:
              - 9d2b4c8f-2087-4738-ba91-7359683c49a4
          name: x-organization-id
          in: header
      responses:
        '200':
          description: Successful Response
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ReceivableRequiredFields'
        '405':
          description: Method Not Allowed
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorSchemaResponse'
        '422':
          description: Validation Error
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/HTTPValidationError'
        '500':
          description: Internal Server Error
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorSchemaResponse'
      security:
        - HTTPBearer: []
components:
  schemas:
    AllowedCountries:
      type: string
      enum:
        - AF
        - AX
        - AL
        - DZ
        - AS
        - AD
        - AO
        - AI
        - AQ
        - AG
        - AR
        - AM
        - AW
        - AU
        - AT
        - AZ
        - BS
        - BH
        - BD
        - BB
        - BY
        - BE
        - BZ
        - BJ
        - BM
        - BT
        - BO
        - BA
        - BW
        - BV
        - BR
        - IO
        - BN
        - BG
        - BF
        - BI
        - KH
        - CM
        - CA
        - IC
        - CV
        - KY
        - CF
        - EA
        - TD
        - CL
        - CN
        - CX
        - CC
        - CO
        - KM
        - CG
        - CD
        - CK
        - CR
        - CI
        - HR
        - CU
        - CY
        - CZ
        - DK
        - DJ
        - DM
        - DO
        - EC
        - EG
        - SV
        - GQ
        - ER
        - EE
        - SZ
        - ET
        - FK
        - FO
        - FJ
        - FI
        - FR
        - GF
        - PF
        - TF
        - GA
        - GM
        - GE
        - DE
        - GH
        - GI
        - GR
        - GL
        - GD
        - GP
        - GU
        - GT
        - GG
        - GN
        - GW
        - GY
        - HT
        - HM
        - VA
        - HN
        - HK
        - HU
        - IS
        - IN
        - ID
        - IR
        - IQ
        - IE
        - IM
        - IL
        - IT
        - JM
        - JP
        - JE
        - JO
        - KZ
        - KE
        - KI
        - KP
        - KR
        - KW
        - KG
        - LA
        - LV
        - LB
        - LS
        - LR
        - LY
        - LI
        - LT
        - LU
        - MO
        - MG
        - MW
        - MY
        - MV
        - ML
        - MT
        - MH
        - MQ
        - MR
        - MU
        - YT
        - MX
        - FM
        - MD
        - MC
        - MN
        - ME
        - MS
        - MA
        - MZ
        - MM
        - NA
        - NR
        - NP
        - NL
        - AN
        - NC
        - NZ
        - NI
        - NE
        - NG
        - NU
        - NF
        - MP
        - MK
        - 'NO'
        - OM
        - PK
        - PW
        - PS
        - PA
        - PG
        - PY
        - PE
        - PH
        - PN
        - PL
        - PT
        - PR
        - QA
        - RE
        - RO
        - RU
        - RW
        - SH
        - KN
        - LC
        - PM
        - VC
        - WS
        - SM
        - ST
        - SA
        - SN
        - RS
        - SC
        - SL
        - SG
        - SK
        - SI
        - SB
        - SO
        - ZA
        - SS
        - GS
        - ES
        - LK
        - SD
        - SR
        - SJ
        - SE
        - CH
        - SY
        - TW
        - TJ
        - TZ
        - TH
        - TL
        - TG
        - TK
        - TO
        - TT
        - TN
        - TR
        - TM
        - TC
        - TV
        - UG
        - UA
        - AE
        - GB
        - US
        - UM
        - UY
        - UZ
        - VU
        - VE
        - VN
        - VG
        - VI
        - WF
        - EH
        - YE
        - ZM
        - ZW
        - BL
        - BQ
        - CW
        - MF
        - SX
    CounterpartType:
      type: string
      enum:
        - individual
        - organization
    ReceivableRequiredFields:
      properties:
        counterpart:
          allOf:
            - $ref: '#/components/schemas/CounterpartFields'
          description: Object describing the required fields for counterpart
          default:
            tax_id:
              description: >-
                The counterpart's taxpayer identification number or tax ID. For
                identification purposes, this field may be required for
                counterparts that are not VAT-registered.
              required: false
            vat_id:
              description: >-
                The counterpart's VAT (Value Added Tax) identification number.
                This field is required for counterparts that are VAT-registered.
              required: false
        entity:
          allOf:
            - $ref: '#/components/schemas/EntityFields'
          description: Object describing the required fields for entity
          default:
            tax_id:
              description: >-
                The entity's taxpayer identification number or tax ID. This
                field is required for entities that are non-VAT registered.
              required: false
            vat_id:
              description: >-
                The entity's VAT (Value Added Tax) identification number. This
                field is required for entities that are VAT-registered.
              required: false
        line_item:
          allOf:
            - $ref: '#/components/schemas/LineItemFields'
          description: Object describing the required fields for line items
          default:
            measure_unit:
              description: >-
                Unit used to measure the quantity of the product (e.g. items,
                meters, kilograms)
              required: false
            tax_rate_value:
              description: >-
                Percent minor units. Example: 12.5% is 1250. This field is only
                required on invoices issued by entities in the US, Pakistan, and
                other unsupported countries.
              required: false
            vat_rate_id:
              description: >-
                Unique identifier of the vat rate object. This field is required
                for all entities in supported countries except the US and
                Pakistan.
              required: false
      additionalProperties: false
      type: object
      examples:
        - line_item:
            vat_rate_id:
              required: true
              description: >-
                Unique identifier of the vat rate object. This field is required
                for all entities in supported countries except the US and
                Pakistan.
            tax_rate_value:
              required: false
              description: >-
                Percent minor units. Example: 12.5% is 1250. This field is only
                required on invoices issued by entities in the US, Pakistan, and
                other unsupported countries.
            measure_unit:
              required: true
              description: >-
                Unit used to measure the quantity of the product (e.g. items,
                meters, kilograms)
          entity:
            tax_id:
              required: false
              description: >-
                The entity's taxpayer identification number or tax ID. This
                field is required for entities that are non-VAT registered.
            vat_id:
              required: true
              description: >-
                The entity's VAT (Value Added Tax) identification number. This
                field is required for entities that are VAT-registered.
          counterpart:
            tax_id:
              required: false
              description: >-
                The counterpart's taxpayer identification number or tax ID. For
                identification purposes, this field may be required for
                counterparts that are not VAT-registered.
            vat_id:
              required: true
              description: >-
                The counterpart's VAT (Value Added Tax) identification number.
                This field is required for counterparts that are VAT-registered.
    ErrorSchemaResponse:
      properties:
        error:
          $ref: '#/components/schemas/ErrorSchema'
      type: object
      required:
        - error
    HTTPValidationError:
      properties:
        detail:
          items:
            $ref: '#/components/schemas/ValidationError'
          type: array
      type: object
    CounterpartFields:
      properties:
        tax_id:
          allOf:
            - $ref: '#/components/schemas/FieldSchema'
          description: Object describing the required field `tax_id` of an counterpart
          default:
            description: >-
              The counterpart's taxpayer identification number or tax ID. For
              identification purposes, this field may be required for
              counterparts that are not VAT-registered.
            required: false
        vat_id:
          allOf:
            - $ref: '#/components/schemas/FieldSchema'
          description: Object describing the required field `vat_id` of an counterpart
          default:
            description: >-
              The counterpart's VAT (Value Added Tax) identification number.
              This field is required for counterparts that are VAT-registered.
            required: false
      additionalProperties: false
      type: object
    EntityFields:
      properties:
        tax_id:
          allOf:
            - $ref: '#/components/schemas/FieldSchema'
          description: Object describing the required field `tax_id` of an entity
          default:
            description: >-
              The entity's taxpayer identification number or tax ID. This field
              is required for entities that are non-VAT registered.
            required: false
        vat_id:
          allOf:
            - $ref: '#/components/schemas/FieldSchema'
          description: Object describing the required field `vat_id` of an entity
          default:
            description: >-
              The entity's VAT (Value Added Tax) identification number. This
              field is required for entities that are VAT-registered.
            required: false
      additionalProperties: false
      type: object
    LineItemFields:
      properties:
        measure_unit:
          allOf:
            - $ref: '#/components/schemas/FieldSchema'
          description: >-
            Object describing the required field `measure_unit` of a line item's
            product
          default:
            description: >-
              Unit used to measure the quantity of the product (e.g. items,
              meters, kilograms)
            required: false
        tax_rate_value:
          allOf:
            - $ref: '#/components/schemas/FieldSchema'
          description: Object describing the required field `tax_rate_value` of a line item
          default:
            description: >-
              Percent minor units. Example: 12.5% is 1250. This field is only
              required on invoices issued by entities in the US, Pakistan, and
              other unsupported countries.
            required: false
        vat_rate_id:
          allOf:
            - $ref: '#/components/schemas/FieldSchema'
          description: Object describing the required field `vat_rate_id` of a line item
          default:
            description: >-
              Unique identifier of the vat rate object. This field is required
              for all entities in supported countries except the US and
              Pakistan.
            required: false
      additionalProperties: false
      type: object
    ErrorSchema:
      properties:
        message:
          type: string
      type: object
      required:
        - message
    ValidationError:
      properties:
        loc:
          items:
            anyOf:
              - type: string
              - type: integer
          type: array
        msg:
          type: string
        type:
          type: string
      type: object
      required:
        - loc
        - msg
        - type
    FieldSchema:
      properties:
        description:
          type: string
          description: Description of the field
        required:
          type: boolean
          description: Whether the field is required
      additionalProperties: false
      type: object
      required:
        - description
        - required
  securitySchemes:
    HTTPBearer:
      type: http
      scheme: bearer

````